const fetch = require('node-fetch')
const config = require('./config.json')

/* La id del codigo QR, se puede obtener escaneando el codigo QR con una app en el celu o con 'zbarimg' en linux
/  Ej: https://scanmevacuno.gob.cl/?f=ASDFGHKLHKLJASLDKAS_187236213781263831278123&c=0
/   "ASDFGHKLHKLJASLDKAS_187236213781263831278123" seria la ID con la cual se consulta y se reemplaza la
/   constante id por la id, tal que quede asi:
/   const id = "ASDFGHKLHKLJASLDKAS_187236213781263831278123"
    */

const id = config.id

fetch(`https://us-central1-scanner-mevacuno.cloudfunctions.net/protoscann`, {
        "headers": {
            "accept": "*/*",
            "accept-encoding": "deflate, gzip, br, zstd",
            "dnt": "1",
            "accept-language": "en",
            "authority": "us-central1-scanner-mevacuno.cloudfunctions.net",
            "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/94.0.4606.54 Safari/537.36",
            // La id de autorizacion vence luego de una hora
            "authorization": `Bearer ${config.token}`,
            "content-type": "application/json",
            "sec-fetch-dest": "empty",
            "sec-fetch-mode": "cors",
            "sec-fetch-site": "cross-site",
            "sec-gpc": "1",
            "referrer": "https://scanmevacuno.gob.cl/",
            "origin": "https://scanmevacuno.gob.cl"

        },
        "referrer": "https://scanmevacuno.gob.cl/",
        "referrerPolicy": "strict-origin-when-cross-origin",
        "body": `{"data":{"a":null,"b":null,"c":"0","f":"${id}","w":null,"ext":null}}`,
        "method": "POST",
        "mode": "cors"
    }).then(res => res.json())
    .then(data => {

        // Informacion acerca de la request
        console.log(data)

        try {
            // Si la variable global_status equivale a green, dira que el pase esta habilitado
            if ((data.result.payload.global_status) == "green") {
                console.log('\nPase Habilitado')
            } else if ((data.result.payload.global_status) == "red") {
                console.log("\nPase no Habilitado")
            }
            // Pero si hay un error o la variable global_status no equivale a green, tirara error
        } catch {
            console.error("\nError en la request")
        }
    });
